--Visual effects
local SKIN = "jetmetalsonic"

freeslot("SPR_JMSA","S_AURAEFFECT","MT_AURAEFFECT",
	"SPR_JMSB","S_JMSBOOSTER_L","S_JMSBOOSTER_R","MT_JMSBOOSTER_L","MT_JMSBOOSTER_R",
	"SPR_JMSC","S_LAUNCHCIRCLE","MT_LAUNCHCIRCLE",
	"SPR_JMSF","S_JMSFUME","MT_JMSFUME","S_JMSBOOSTERFUME","MT_JMSBOOSTERFUME",
	"SPR_JMSO","S_CHARGEORB","MT_CHARGEORB",
	"SPR_JMSS","S_JMSSUPEREFF","MT_JMSSUPEREFF",
	"S_JMSZAP","MT_JMSZAP",
	"SKINCOLOR_JETMETAL")
for i = 1, 5
	freeslot("SKINCOLOR_SUPERJETMETAL"..i)
end

skincolors[SKINCOLOR_JETMETAL] = {name = "JetMetal", invcolor = SKINCOLOR_BONE, ramp = {3,15,19,23,25,27,29,29,29,30,30,30,30,30,31,31}, accessible = true}
skincolors[SKINCOLOR_SUPERJETMETAL1] = {name = "Super JetMetal 1", ramp = {3,15,19,23,25,27,29,29,29,30,30,30,30,30,31,31}, accessible = false}
skincolors[SKINCOLOR_SUPERJETMETAL2] = {name = "Super JetMetal 2", ramp = {3,15,19,23,236,79,238,238,238,239,239,239,239,239,239,239}, accessible = false}
skincolors[SKINCOLOR_SUPERJETMETAL3] = {name = "Super JetMetal 3", ramp = {89,65,190,190,77,191,78,78,78,79,79,79,79,238,238,239}, accessible = false}
skincolors[SKINCOLOR_SUPERJETMETAL4] = {name = "Super JetMetal 4", ramp = {89,85,66,190,190,77,77,191,78,78,78,79,79,79,238,239}, accessible = false}
skincolors[SKINCOLOR_SUPERJETMETAL5] = {name = "Super JetMetal 5", ramp = {89,85,65,66,190,190,190,77,191,191,78,78,79,79,238,239}, accessible = false}

addHook("PreThinkFrame", do
	for p in players.iterate
		if not (p.mo and p.mo.valid and p.mo.skin == SKIN) return end

		if p.menu.contents[1][2].value == 0
			p.JMSVFXCOLOR = SKINCOLOR_YELLOW
		elseif p.menu.contents[1][2].value == 1
			p.JMSVFXCOLOR = SKINCOLOR_ORANGE
		elseif p.menu.contents[1][2].value == 2
			p.JMSVFXCOLOR = SKINCOLOR_CRIMSON
		elseif p.menu.contents[1][2].value == 3
			p.JMSVFXCOLOR = SKINCOLOR_AETHER
		end
	end
end)

local function SpawnZapEffect(mo, freq, velocity, color)
	if leveltime % freq ~= 0 return end

	local fa = P_RandomRange(1, 360) * ANG1
	local md = P_RandomRange(1, 360) * ANG1

	local x_adjust = FixedMul(cos(fa), mo.radius)
	local y_adjust = FixedMul(sin(fa), mo.radius)
	local z_adjust = mo.height/2 + FixedMul(sin(md), mo.height/2)

	local effect = P_SpawnMobjFromMobj(mo, x_adjust, y_adjust, z_adjust, MT_JMSZAP)
	effect.scale = mo.scale
	effect.color = color
	effect.colorized = true

	if velocity
		P_InstaThrust(effect, R_PointToAngle2(mo.x, mo.y, effect.x, effect.y), FixedMul(velocity, mo.scale))
		P_SetObjectMomZ(effect, velocity, false)
	end
end

function A_JMSZapThink(actor, var1, var2)
	if not actor.fuse
		actor.fuse = var1
	end

	local frame = FF_TRANS30|FF_FULLBRIGHT
	if actor.fuse % 4 == 1
		actor.frame = B|frame
	elseif actor.fuse % 4 == 2
		actor.frame = C|frame
	elseif actor.fuse % 4 == 3
		actor.frame = D|frame
	else
		actor.frame = A|frame
	end

	local alpha = abs(var1 + 1 - actor.fuse) * FF_TRANS10
	actor.frame = $ | alpha
end

states[S_JMSZAP] = {SPR_WZAP, A|FF_FULLBRIGHT|FF_TRANS30, 1, A_JMSZapThink, 6, 0, S_JMSZAP}

mobjinfo[MT_JMSZAP] = {spawnstate = S_JMSZAP, flags = MF_NOGRAVITY|MF_NOBLOCKMAP}

rawset(_G, "SpawnChargeOrb", function(p, freq)
	if leveltime % freq ~= 0 return end

	local fa = P_RandomRange(1, 360) * ANG1
	local md = P_RandomRange(1, 360) * ANG1
	if P_IsObjectOnGround(p.mo)
		md = P_RandomRange(1, 180) * ANG1
	end
	local radius = FixedMul(80*FRACUNIT, p.mo.scale)

	local x_adjust = FixedMul(cos(fa), radius)
	local y_adjust = FixedMul(sin(fa), radius)
	local z_adjust = p.mo.height/2 + FixedMul(sin(md), radius)

	local effect = P_SpawnMobjFromMobj(p.mo, x_adjust, y_adjust, z_adjust, MT_CHARGEORB)
	effect.scale = p.mo.scale/18
	effect.color = p.JMSVFXCOLOR
	effect.tracer = p.mo
end)

function A_ChargeOrbThink(actor, var1, var2)
	local t = actor.tracer

	/*if not t.player.chargeability.charging
		P_RemoveMobj(actor)
		return
	end*/

	if not actor.fuse
		actor.fuse = var1
	end

	local ghost = P_SpawnGhostMobj(actor)
	ghost.fuse = var2

	local x_adjust = P_ReturnThrustX(t, t.angle, FixedMul(-12*FRACUNIT, t.scale))
	local y_adjust = P_ReturnThrustY(t, t.angle, FixedMul(-12*FRACUNIT, t.scale))
	local z_adjust = t.height/2

	local dist = P_AproxDistance(P_AproxDistance(t.x + x_adjust - actor.x, t.y + y_adjust - actor.y), t.z + z_adjust - actor.z)
	local speed = dist / actor.fuse

	actor.momx = FixedMul(FixedDiv(t.x + x_adjust - actor.x, dist), speed)
	actor.momy = FixedMul(FixedDiv(t.y + y_adjust - actor.y, dist), speed)
	actor.momz = FixedMul(FixedDiv(t.z + z_adjust - actor.z, dist), speed)
end

states[S_CHARGEORB] = {SPR_JMSO, A|FF_TRANS30|FF_FULLBRIGHT, 1, A_ChargeOrbThink, 12, 6, S_CHARGEORB}

mobjinfo[MT_CHARGEORB] = {spawnstate = S_CHARGEORB, flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_NOBLOCKMAP}

rawset(_G, "SpawnAuraEffect", function(p)
	local aura = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_AURAEFFECT)
	aura.tracer = p.mo
	aura.color = p.JMSVFXCOLOR
	aura.scale = p.mo.scale
	aura.dispoffset = 1
	if not (aura.flags2 & MF2_LINKDRAW)
		aura.flags2 = $|MF2_LINKDRAW
	end
end)

function A_AuraEffectThink(actor, var1, var2)
	local t = actor.tracer
	local p = t.player
	actor.angle = p.drawangle
	actor.scale = t.scale

	if t.eflags & MFE_VERTICALFLIP
		actor.eflags = $ | MFE_VERTICALFLIP
		P_TeleportMove(actor, t.x, t.y, t.z + t.height)
	else
		P_TeleportMove(actor, t.x, t.y, t.z)
	end

	local frame = FF_FULLBRIGHT
	if leveltime % 8 < 2
		frame = $ | FF_TRANS40
	elseif leveltime % 8 < 4
		frame = $ | FF_TRANS60
	elseif leveltime % 8 < 6
		frame = $ | FF_TRANS80
	else
		frame = $ | FF_TRANS60
	end

	if t.state == S_PLAY_CHARGETHOK
	or t.state == S_PLAY_DASH
		actor.frame = frame | A
	elseif t.state == S_PLAY_CHARGEJUMP
		actor.frame = frame | B
	elseif p.chargeability.stomp
		actor.frame = frame | C
	else
		P_RemoveMobj(actor)
	end
end

states[S_AURAEFFECT] = {SPR_JMSA, A, 1, A_AuraEffectThink, 0, 0, S_AURAEFFECT}

mobjinfo[MT_AURAEFFECT] = {spawnstate = S_AURAEFFECT, flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_NOBLOCKMAP}

rawset(_G, "SpawnLaunchEffect", function(p, size, dir)
	local effect = P_SpawnMobjFromMobj(p.mo, 0, 0, p.mo.height/2, MT_LAUNCHCIRCLE)
	effect.color = p.JMSVFXCOLOR
	effect.scale = FixedMul(size, p.mo.scale)
	if dir
		effect.renderflags = RF_PAPERSPRITE
		effect.angle = p.mo.angle + ANGLE_90
	else
		effect.renderflags = RF_FLOORSPRITE
	end
end)

states[S_LAUNCHCIRCLE] = {SPR_JMSC, FF_ANIMATE|FF_TRANS50|FF_FULLBRIGHT, 7, nil, 6, 1, S_NULL}

mobjinfo[MT_LAUNCHCIRCLE] = {spawnstate = S_LAUNCHCIRCLE, flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_NOBLOCKMAP}

local function InFumeState(p)
	local mo = p.mo

	if mo.state == S_PLAY_WALK
	or mo.state == S_PLAY_RUN
	or mo.state == S_PLAY_DASH
	or mo.state == S_PLAY_CHARGE
	or mo.state == S_PLAY_CHARGETHOK
	or mo.state == S_PLAY_CHARGEJUMP
	or mo.state == S_PLAY_DASHREADY
	or p.Homing
		return true
	else
		return false
	end
end

local function SpawnJMSFume(p)
	local mo = p.mo

	local x_adjust = P_ReturnThrustX(mo, mo.angle, -17*mo.scale)
	local y_adjust = P_ReturnThrustY(mo, mo.angle, -17*mo.scale)
	local z_adjust = mo.height/2
	if p.pflags & PF_STARTDASH|PF_SPINNING
		if mo.eflags & MFE_VERTICALFLIP
			z_adjust = $ - mo.height/3
		else
			z_adjust = $ + mo.height/3
		end
	end

	if not (mo.eflags & MFE_UNDERWATER)
		local fume = P_SpawnMobjFromMobj(mo, x_adjust, y_adjust, z_adjust, MT_JMSFUME)
		fume.color = p.JMSVFXCOLOR
		fume.tracer = mo
		fume.scale = 3*mo.scale/4

		return fume
	elseif leveltime % 3 == 0
		P_SpawnMobjFromMobj(mo, x_adjust, y_adjust, z_adjust, MT_SMALLBUBBLE)
		return nil
	end
end

function A_JMSFumeThink(actor, var1, var2)
	local t = actor.tracer
	local p = t.player

	if not actor.timer
		actor.timer = 0
	end

	local x_adjust = P_ReturnThrustX(t, t.angle, -17*t.scale)
	local y_adjust = P_ReturnThrustY(t, t.angle, -17*t.scale)
	local z_adjust = t.height/2
	if p.pflags & PF_STARTDASH
		if actor.eflags & MFE_VERTICALFLIP
			z_adjust = $ - t.height/3
		else
			z_adjust = $ + t.height/3
		end
	end
	P_TeleportMove(actor, t.x + x_adjust, t.y + y_adjust, t.z + z_adjust)

	if t.flags2 & MF2_DONTDRAW
		actor.flags2 = $ | MF2_DONTDRAW
	else
		actor.flags2 = $ & ~MF2_DONTDRAW
	end

	local frame = FF_FULLBRIGHT
	if actor.timer < 1
		actor.frame = frame | D
	elseif actor.timer < 3
		actor.frame = frame | E
	elseif actor.timer % 3 == 0
		actor.frame = frame | A
	elseif actor.timer % 3 == 1
		actor.frame = frame | B
	else
		actor.frame = frame | C
	end

	if actor.timer > 3
		if p.speed < p.runspeed
			actor.scale = t.scale/3
		elseif p.speed < skins[p.mo.skin].normalspeed - 5*FRACUNIT
			actor.scale = t.scale/2
		else
			actor.scale = 3*t.scale/4
		end
	else
		actor.scale = 3*t.scale/4
	end

	if t.state == S_PLAY_DASH
	or t.state == S_PLAY_CHARGETHOK
	or t.state == S_PLAY_CHARGEJUMP
	or p.Homing
		local ghost = P_SpawnGhostMobj(actor)
		ghost.fuse = var1
	end

	actor.timer = $ + 1

	if not InFumeState(p)
		P_RemoveMobj(actor)
	end
end

states[S_JMSFUME] = {SPR_JMSF, D|FF_FULLBRIGHT, 1, A_JMSFumeThink, 6, 0, S_JMSFUME}

mobjinfo[MT_JMSFUME] = {spawnstate = S_JMSFUME, flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_NOBLOCKMAP}

local function SpawnJMSBoosterFume(mo, color)
	local var1 = states[S_JMSBOOSTERFUME].var1

	local x_adjust = P_ReturnThrustX(mo, mo.angle, var1*mo.scale)
	local y_adjust = P_ReturnThrustY(mo, mo.angle, var1*mo.scale)

	if not (mo.eflags & MFE_UNDERWATER)
		local fume = P_SpawnMobjFromMobj(mo, x_adjust, y_adjust, 0, MT_JMSBOOSTERFUME)
		fume.tracer = mo
		fume.color = color
		fume.scale = 3*mo.scale/4

		return fume
	elseif leveltime % 3 == 0
		P_SpawnMobjFromMobj(mo, x_adjust, y_adjust, 0, MT_SMALLBUBBLE)
		return nil
	end
end

function A_JMSBoosterFumeThink(actor, var1, var2)
	local t = actor.tracer
	if not actor.timer
		actor.timer = 0
	end

	local x_adjust = P_ReturnThrustX(t, t.angle, var1*t.scale)
	local y_adjust = P_ReturnThrustY(t, t.angle, var1*t.scale)
	local z_adjust = FixedMul(var2, actor.scale) + FixedMul(var2, (t.scale - actor.scale))
	if actor.eflags & MFE_VERTICALFLIP
		z_adjust = -$
	end
	P_TeleportMove(actor, t.x + x_adjust, t.y + y_adjust, t.z + z_adjust)

	if t.flags2 & MF2_DONTDRAW
		actor.flags2 = $ | MF2_DONTDRAW
	else
		actor.flags2 = $ & ~MF2_DONTDRAW
	end

	local frame = FF_FULLBRIGHT
	if actor.timer < 1
		actor.frame = frame | D
	elseif actor.timer < 3
		actor.frame = frame | E
	elseif actor.timer % 3 == 0
		actor.frame = frame | A
	elseif actor.timer % 3 == 1
		actor.frame = frame | B
	else
		actor.frame = frame | C
	end

	actor.timer = $ + 1
end

states[S_JMSBOOSTERFUME] = {SPR_JMSF, D|FF_FULLBRIGHT, 1, A_JMSBoosterFumeThink, -17, 11*FRACUNIT/2, S_JMSBOOSTERFUME}

mobjinfo[MT_JMSBOOSTERFUME] = {spawnstate = S_JMSBOOSTERFUME, flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_NOBLOCKMAP}

local function SpawnJMSBooster(p, n)
	local object = n - 1 + MT_JMSBOOSTER_L

	local booster = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, object)
	booster.tracer = p.mo
	if i == 2
		booster.mirrored = true
	end

	return booster
end

function A_JMSBoosterThink(actor, var1, var2)
	local t = actor.tracer
	local p = t.player

	if t.skin ~= SKIN
		if actor.jmsfume and actor.jmsfume.valid
			P_RemoveMobj(actor.jmsfume)
		end
		P_RemoveMobj(actor)
		return
	end

	local var1up = var1>>FRACBITS
	local var1low = var1 % FRACUNIT
	local var2up = var2>>FRACBITS
	local var2low = var2 % FRACUNIT

	actor.scale = t.scale
	actor.color = t.color
	actor.colorized = t.colorized

	if t.flags2 & MF2_DONTDRAW
		actor.flags2 = $ | MF2_DONTDRAW
	else
		actor.flags2 = $ & ~MF2_DONTDRAW
	end

	if var1low
		actor.mirrored = true
	end
	
	if p.powers[pw_super]
		SpawnZapEffect(actor, 2, nil, p.JMSVFXCOLOR)
	end

	if p.playerstate == PST_DEAD
		actor.flags = $ & ~(MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY)
		if actor.jmsfume
			P_RemoveMobj(actor.jmsfume)
			actor.jmsfume = nil
		end

		if leveltime % 8 == 0
		and not (actor.flags2 & MF2_DONTDRAW)
			A_BossScream(actor, 1, MT_BOSSEXPLODE)
			S_StartSound(actor, sfx_s3kb4)
		end

		if not p.deadalready
			P_InstaThrust(actor, actor.angle + P_RandomRange(-20, 20) * ANG1, p.prevspeed/2)
			actor.momz = 2*t.momz/3
		elseif not P_IsObjectOnGround(actor)
			if var1low
				actor.rollangle = $ - ANG10
			else
				actor.rollangle = $ + ANG10
			end
		else
			actor.momx = 0
			actor.momy = 0
		end
		return
	end

	local offsetz
	if t.eflags & MFE_VERTICALFLIP
		actor.eflags = $|MFE_VERTICALFLIP
		actor.flags2 = $|MF2_OBJECTFLIP
		offsetz = t.height - FixedMul(var1up * FRACUNIT, t.scale)
	else
		actor.eflags = $ & ~MFE_VERTICALFLIP
		actor.flags2 = $ & ~MF2_OBJECTFLIP
		offsetz = FixedMul(var1, actor.scale)
	end
	if leveltime % (2*TICRATE) < TICRATE
		offsetz = FixedMul($ + (leveltime % TICRATE) / 8*FRACUNIT, t.scale)
	else
		offsetz = FixedMul($ + 34*FRACUNIT/8 - (leveltime % TICRATE) / 8*FRACUNIT, t.scale)
	end

	local angle = p.drawangle
	actor.angle = angle

	local foffsetx = P_ReturnThrustX(t, angle, FixedMul(var2up * FRACUNIT, t.scale))
	local foffsety = P_ReturnThrustY(t, angle, FixedMul(var2up * FRACUNIT, t.scale))
	local boffsetx = P_ReturnThrustX(t, angle + ANGLE_90, FixedMul(var2low * FRACUNIT, t.scale))
	local boffsety = P_ReturnThrustY(t, angle + ANGLE_90, FixedMul(var2low * FRACUNIT, t.scale))

	P_TeleportMove(actor, t.x + foffsetx + boffsetx, t.y + foffsety + boffsety, t.z + offsetz)

	if InFumeState(p)
	and t.state ~= S_PLAY_WALK
		if not actor.jmsfume
			actor.jmsfume = SpawnJMSBoosterFume(actor, p.JMSVFXCOLOR)
		elseif actor.jmsfume
			if t.state == S_PLAY_DASH
			or t.state == S_PLAY_CHARGETHOK
			or t.state == S_PLAY_CHARGEJUMP
			or p.Homing
				local ghost = P_SpawnGhostMobj(actor.jmsfume)
				ghost.fuse = states[S_JMSFUME].var1
			end
		end
	elseif actor.jmsfume
		P_RemoveMobj(actor.jmsfume)
		actor.jmsfume = nil
	end

	if not actor.jmsfume return end
	if not actor.jmsfume.timer return end

	if actor.jmsfume.timer > 3
		if p.speed < p.runspeed
			actor.jmsfume.scale = t.scale/3
		else
			actor.jmsfume.scale = t.scale/2
		end
	else
		actor.jmsfume.scale = t.scale/2
	end
end

states[S_JMSBOOSTER_L] = {SPR_JMSB, A, 1, A_JMSBoosterThink, 40<<FRACBITS, -10<<FRACBITS+20, S_JMSBOOSTER_L}
states[S_JMSBOOSTER_R] = {SPR_JMSB, A, 1, A_JMSBoosterThink, 40<<FRACBITS+1, -10<<FRACBITS-20, S_JMSBOOSTER_R}

mobjinfo[MT_JMSBOOSTER_L] = {
	spawnstate = S_JMSBOOSTER_L,
	radius = 6*FRACUNIT,
	height = 6*FRACUNIT,
	flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_NOBLOCKMAP
}
mobjinfo[MT_JMSBOOSTER_R] = {
	spawnstate = S_JMSBOOSTER_R,
	radius = 6*FRACUNIT,
	height = 6*FRACUNIT,
	flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_NOBLOCKMAP
}

function A_JMSSuperEffectThink(actor, var1, var2)
	if not actor.fuse
		actor.fuse = var2
	end

	local frame = FF_TRANS40|FF_FULLBRIGHT|FF_PAPERSPRITE
	if actor.fuse % 4 == 1
		actor.frame = B|frame
	elseif actor.fuse % 4 == 2
		actor.frame = C|frame
	elseif actor.fuse % 4 == 3
		actor.frame = D|frame
	else
		actor.frame = A|frame
	end

	local fa = FixedAngle(actor.info.speed) + actor.angle - ANGLE_90
	actor.angle = fa + ANGLE_90

	if not actor.expradius
		actor.expradius = var1 / var2
	else
		actor.expradius = $ + var1 / var2
	end
	local radius = FixedMul(actor.expradius, actor.scale)

	local offsetx = FixedMul(cos(fa), radius)
	local offsety = FixedMul(sin(fa), radius)

	P_TeleportMove(actor, actor.x + offsetx, actor.y + offsety, actor.z)

	local alpha = abs(var2 + 1 - actor.fuse)/3 * FF_TRANS10
	actor.frame = $ | alpha
end

states[S_JMSSUPEREFF] = {SPR_JMSS, A|FF_TRANS40|FF_FULLBRIGHT|FF_PAPERSPRITE, 1, A_JMSSuperEffectThink, 32*FRACUNIT, 12, S_JMSSUPEREFF}

mobjinfo[MT_JMSSUPEREFF] = {spawnstate = S_JMSSUPEREFF, flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_NOBLOCKMAP}

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid and p.mo.skin == SKIN) return end
	if p.powers[pw_carry] return end

	if p.mo.state >= S_PLAY_SUPER_TRANS1 and p.mo.state <= S_PLAY_SUPER_TRANS6
		SpawnZapEffect(p.mo, 1, 9*FRACUNIT, p.JMSVFXCOLOR)
	elseif p.powers[pw_super]
		SpawnZapEffect(p.mo, 2, 3*FRACUNIT, p.JMSVFXCOLOR)
	else
		SpawnZapEffect(p.mo, 2, nil, p.JMSVFXCOLOR)
	end

	for i = 1, 2
		if not (p["jmsbooster" .. i] and p["jmsbooster" .. i].valid)
			p["jmsbooster" .. i] = SpawnJMSBooster(p, i)
		end
	end

	if InFumeState(p)
	and not p.jmsfume
		p.jmsfume = SpawnJMSFume(p)
	elseif p.jmsfume and not p.jmsfume.valid
		p.jmsfume = nil
	end
end)